#!/bin/bash

if $(yad --title "Dupliquer Malinux Télé" --text "Cet outil vous permet de créer une copie du système Malinux Télé sur une autre carte SD. En insérant cette carte SD dans un autre Raspbery Pi, vous créerez un nouvel exemplaire de Malinux Télé.\n\nAvant de commencer:\nSi jamais vous aviez inséré une clef USB dans Malinux Télé, retirez-là. Le système de copie pourrait la confondre avec la carte SD et copier le système Malinux Télé dessus (ce qui l'éffacerai)\n\nUne carte SD de 4GO (4 Gigas) est nécéssaire.\nLes données de cette cartes seront remplacées par le système Malinux Télé. Si vous avez des fichiers sur cette carte, copiez-les ailleurs pour ne pas les perdre!\n\nLorsque vous cliquerez sur 'valider' ce programme va attendre que vous branchiez un adaptateur USB contenant une carte SD dans Malinux Télé. Il faudra débrancher la souris ou le hub (multiport) et brancher l'adaptateur à la place." --width 500); then

yad --text "Veuillez débrancher la souris (ou le multiport USB) et brancher un adaptateur USB contenant une carte SD vers laquelle Malinux Télé sera copié. \n\nLa copie commencera automatiquement dès qu'une carte SD aura été détectée." --title="En attente d'une carte SD" --button=gtk-cancel&
pidYadAttente=$!

devCarte=""
while [ -z "$devCarte" ]; do
devCarte=$(sudo fdisk -l | grep -o "Disk /dev[^:]*:" | sed "s/^Disk //g; s/:$//g" | grep -v /dev/mmcblk0)

if ! kill -0 $pidYadAttente; then
#annulation
exit
fi

done
kill $pidYadAttente

blocFin=$(sudo fdisk -l /dev/mmcblk0 | grep -o "/dev/mmcblk0p2[ ]*[0-9]*[ ]*[0-9]*" | grep -o "[0-9]*$" | sed "s/$/ \/ 2 +1 /g" | bc)

sudo mount /dev/mmcblk0p1 -oremount,ro
sudo mount /dev/mmcblk0p3 -oremount,ro


sudo killall dd #hack sale: on les les autres dd (il ne devrait pas y en avoir) pour ne pas etre gene pour recup le pid de notre dd

dd if=/dev/mmcblk0 of=$devCarte bs=1024 count=$blocFin 2>&1 | grep -o --line-buffered "^[0-9]* octets" | sed -u "s/ octets/ * 100 \/ 1024 \/ 1024 \/ \($blocFin \/ 1024 \) /g" | bc | yad --progress --text "Copie de Malinux Télé en cours (écriture sur $devCarte)" --title "Copie en cours..."  --width 600 --no-buttons&


pidDd=$(ps -A | grep " dd$" | grep -o "^[ ]*[0-9]*" | sed "s/ //g")

while true; do
if ! kill -SIGUSR1 $pidDd; then
break
fi
wmctrl -c "Périphérique amovible inseré"
sleep 20s;
done;

flush

killall yad
yad --title="C'est fini." --button=gtk-close --text "C'est fini. Si tout s'est bien passé, vous pouvez retirer la carte SD et l'insérer dans un Raspberry Pi pour fabriquer un nouvel exemplaire de Malinux Télé."

sudo mount /dev/mmcblk0p3 -oremount,rw


fi

